[tox]
minversion = 3.18.0
envlist = py3,pep8
ignore_basepython_conflict = true

[testenv]
basepython = python3
deps =
  -c{env:TOX_CONSTRAINTS_FILE:https://releases.openstack.org/constraints/upper/master}
  -r{toxinidir}/test-requirements.txt
  -r{toxinidir}/requirements.txt
commands = stestr run --slowest {posargs}

[testenv:pep8]
deps =
  -r{toxinidir}/test-requirements.txt
commands =
  pre-commit run -a
  # Run security linter
  bandit -r oslo_i18n -x tests -n5

[testenv:venv]
commands = {posargs}

[testenv:docs]
allowlist_externals =
  rm
deps =
  {[testenv]deps}
  -r{toxinidir}/doc/requirements.txt
commands =
  rm -rf doc/build
  sphinx-build -W --keep-going -b html doc/source doc/build/html

[testenv:cover]
setenv =
  PYTHON=coverage run --source oslo_i18n --parallel-mode
commands =
  stestr run {posargs}
  coverage combine
  coverage html -d cover
  coverage xml -o cover/coverage.xml


[flake8]
# E123, E125 skipped as they are invalid PEP-8.
# E731 skipped as assign a lambda expression

show-source = True
ignore = E123,E125,E731,W504

# H106: Don’t put vim configuration in source files
# H203: Use assertIs(Not)None to check for None
enable-extensions=H106,H203
exclude=.venv,.git,.tox,dist,doc,*lib/python*,*egg,build,__init__.py

[hacking]
import_exceptions =
  oslo_i18n._i18n._

[testenv:releasenotes]
whitelist_externals =
  rm
deps =
  -c{env:TOX_CONSTRAINTS_FILE:https://releases.openstack.org/constraints/upper/master}
  -r{toxinidir}/doc/requirements.txt
commands =
  rm -rf releasenotes/build
  sphinx-build -a -E -W -d releasenotes/build/doctrees --keep-going -b html releasenotes/source releasenotes/build/html
